package K::Common;

use strict;
use threads ();
use threads::shared qw/is_shared/;

require Exporter;
use base qw/Exporter/;

our @EXPORT = qw(debug load_file writef genran msleep rnd loadcfg fsplice);

#thread-safe. if offset is out of range then last element will be removed
#Distorts elements order
sub fsplice($$)
{
	my ($array, $offset) = @_;
	
	my @array = @{$array};
	
	my $size = $#array;
	if(is_shared @array)
	{
		lock @array;
		($array[$offset], $array[$size]) = ($array[$size], $array[$offset]);
		$#array = $size - 2;
	}
	else
	{
		($array[$offset], $array[$size]) = ($array[$size], $array[$offset]);
		$#array = $size - 2;
	}
}

sub genran($)
{
	my $res;
	my @list = (48..57, 65..90, 97..122);
	$res .= chr $list[rand scalar @list] for 1..$_[0];
	return $res;
}

sub debug($) 
{
	my (undef, undef, undef, $day, undef, undef, undef, undef, undef) = localtime time;
	open F, '>>', $day.'_debug.txt';
	print F 'Time: '.scalar localtime(time)."\n".$_[0]."\n";
	close F;
}

sub load_file($)
{
    open F, '<', $_[0] or die "Can't open $_[0]\n";
	chomp(my @str = <F>);
	close F;
	
	return @str;
}

sub writef($$$)
{
	if($_[2])
	{
		open F, '>', $_[0] or warn "$_[0] - $!\n";
	}
	else
	{
		open F, '>>', $_[0] or warn "$_[0] - $!\n";
	}
	print F $_[1];
	close F;
}

sub msleep($)
{
	select undef, undef, undef, $_[0];
}

sub rnd($$)
{
	return $_[0] + int rand $_[1] - $_[0] + 1;
}

sub loadcfg($)
{
	open F, '<', $_[0] or die "Can't load config file - $_[0]\n";
	chomp(my @list = <F>);
	close F;

	my %cfg = map { /^(\w+)=(.+)$/ && $1 => $2 } @list;
	return %cfg;
}

1;