use strict;
use warnings;
use K::AntiCaptcha;
use K::Web;
use K::Common;
use threads;
use threads::shared;
use GD::Tiler qw/tile/;
use GD;

my %config = loadcfg('config.txt');
my %string = loadcfg('string.dat');

my (@login, @passw, @proxy, @names, @sname);
share @proxy;

@login = load_file($config{'login_file'}) if $config{'login_gen'};
@passw = load_file($config{'passw_file'}) if $config{'passw_gen'};
@proxy = load_file($config{'proxy_file'}) if $config{'use_proxy'};
@names = load_file($config{'name_file'});
@sname = load_file($config{'surname_file'});

my ($login_size, $passw_size, $proxy_size, $names_size, $sname_size) = (scalar @login, scalar @passw, scalar @proxy, scalar @names, scalar @sname);

my $to_reg : shared = $config{'reg_num'};

my $acap = K::AntiCaptcha->new(host => $config{'ac_url'}, key => $config{'ac_key'}, min_len => 6, max_len => 6);
my %stats : shared = (ok => 0, error => 0, captcha => 0);

$| = 1;
my @trl = ();

$trl[$_] = threads->create(\&main) for 0..$config{'threads'} - 1;
$_->join for @trl;

print "\nPress any key to exit...\n";
<>;

sub main
{
	my ($web) = new K::Web;
	my $proxy_limit = 0;
	
	while(1)
	{
		last if $to_reg <= 0;
		
		if($config{'use_proxy'} && $proxy_limit <= 0)
		{
			$proxy_limit = $config{'proxy_limit'};
			sleep 1 until proxy($web);
		}
		elsif($config{'use_proxy'})
		{
			$proxy_limit--;
		}
		
		if(register($web))
		{
			inc('ok');
			{
				lock $to_reg;
				$to_reg--;
			}
		}
		else
		{
			inc('error');
		}
	}
}

sub register
{
	my $web = shift;
	
	$web->set_cookie();
	my $page = $web->request('GET', 'http://win.mail.ru', 80, '/cgi-bin/signup');
	$web->set_cookie_ex($page);
	
	my ($id) = ($page =~ /$string{'reg_id'}/o);
	my ($x_id) = ($page =~ /$string{'x_reg_id'}/o);
	
	my @x_fields = ($page =~ /$string{'x_fields'}/go);
	my @x_images = ($page =~ /$string{'x_images'}/go);
	
	@x_images = ($page =~ /$string{'x_single'}/go) unless @x_images;
	
	if($id && $x_id && scalar @x_fields == 13 && scalar @x_images > 0)
	{
		cout(" Registering...");
		my %s = ();
		@x_fields = grep(!$s{$_}++, @x_fields);
		
		my ($name, $surname, $day, $year, $month, $gender, $login, $passw, $quest, $answr, $captcha, $domain);
		
		$captcha = captcha($web, $x_id, \@x_images);
		
		$login = $config{'login_gen'} ? $login[rand $login_size] : genran(rnd(6, 12));
		$passw = $config{'passw_gen'} ? $passw[rand $passw_size] : genran(rnd(8, 12));
		$domain = (split /,/, $config{'reg_domain'})[rand $config{'reg_domain'} =~ tr/,//];
		
		($day, $year, $month, $gender) = (rnd(1, 30), rnd(1950, 1996), rnd(1, 12), rnd(1, 2));
		($name, $surname) = ($names[rand $names_size], $sname[rand $sname_size]);
		$quest = $string{'reg_quest'};
		$answr = genran(rnd(10,20));
		
		my @temp = ($name, $surname, $day, $year, $gender, $login, $passw, $passw, "", $answr, "", $captcha);
		
		my %x_hash = map { $_ => shift @temp } @x_fields;

		my $req = "signup_b=1&ID=$id&Count=1&back=&browserData=NoJS&Mrim.Country=0&Mrim.Region=0&x_reg_id=$x_id&security_image_id=&geo_countryId=undefined&geo_cityId=undefined&geo_regionId=undefined&geo_country=&geo_place=&BirthMonth=$month&your_town=&RemindPhone=&RegistrationDomain=$domain&Password_Question=$quest&";
		
		$req .= join '&', map {"x_$_=$x_hash{$_}"} keys %x_hash;
		
		$page = $web->request('POST', 'http://win.mail.ru', 80, '/cgi-bin/reg', 1, $req);
		
		if($page =~ /$string{'reg_redirect'}/o)
		{
			writef($config{'ok_reg'}, "$login\@$domain:$passw\n", 0);
			cout("   [+] $login\@$domain:$passw");
			return 1;
		}
		else
		{
			debug($page) && debug($req) if $config{'verbose'};
			cout("   [-] Wrong captcha id/IP limit exceed");
		}
	}
	else
	{
		debug($page) if $config{'verbose'};
		cout(" Can't parse registration data");
	}
	
	return 0;
}

sub proxy
{
	my $web = shift;
	
	unless(@proxy)
	{
		cout("No more proxy");
		threads->exit;
	}
	
	my $proxy = shift @proxy;
	
	if($proxy)
	{
		if($config{'proxy_auth'})
		{
			$web->proxy_auth($config{'proxy_login'}, $config{'proxy_passw'}) if $config{'proxy_type'} == 0;
			$web->socks_auth($config{'proxy_login'}, $config{'proxy_passw'}) if $config{'proxy_type'} == 1;
		}
		$web->proxy($config{'proxy_type'} + 1, $proxy);
		my $test = $web->request('GET', 'http://mail.ru', 80, '/', 0, '', 512);

		if($test =~ /$string{'proxy_check'}/io)
		{
			cout("Using proxy $proxy");
			return 1;
		}
		else
		{
			debug($test) if $config{'verbose'};
			cout("Bad proxy $proxy");
		}
	}
	
	return 0;
}

sub captcha
{
	my ($web, $x_id, $a_ref) = @_;
	
	inc('captcha');
	#.....
	
	my $im;
	my $answ = 0;
	
	if(scalar @{$a_ref} == 3)
	{
		my ($blob1) = ($web->request('GET', 'http://win.mail.ru', 80, '/cgi-bin/x_image?'.(shift @{$a_ref}).'&num=1&x_reg_id='.$x_id)  =~ /\r\n\r\n(.*)/s);
		my ($blob2) = ($web->request('GET', 'http://win.mail.ru', 80, '/cgi-bin/x_image?'.(shift @{$a_ref}).'&num=2&x_reg_id='.$x_id)  =~ /\r\n\r\n(.*)/s);
		my ($blob3) = ($web->request('GET', 'http://win.mail.ru', 80, '/cgi-bin/x_image?'.(shift @{$a_ref}).'&num=3&x_reg_id='.$x_id)  =~ /\r\n\r\n(.*)/s);
	
	
	
		if($blob1 && $blob2 && $blob3)
		{
			my $im1 = GD::Image->newFromJpegData($blob1);
			my $im2 = GD::Image->newFromJpegData($blob2);
			my $im3 = GD::Image->newFromJpegData($blob3);
		
			$im = GD::Tiler->tile
			(
				Images => [$im1, $im2, $im3],
				Width => 225,
				Height => 51,
				Coordinates => [0,0,75,0,150,0]
			);
		}
	}
	elsif(scalar @{$a_ref} == 1)
	{
		($im) = ($web->request('GET', 'http://win.mail.ru', 80, '/cgi-bin/x_get_image_v3?'.(shift @{$a_ref}).'&x_reg_id='.$x_id)  =~ /\r\n\r\n(.*)/s);
	}

	if($im)
	{
		cout("  Recognizing captcha...");
		
		my $id = $acap->recognize($im, 1);
		if($id)
		{
			sleep 3 until($answ = $acap->get_status($id));
		}
	}
	else
	{
		cout("  Can't get captcha image");
	}
	
	return $answ;
}

sub inc
{
	lock %stats;
	$stats{$_[0]} += $_[1] ? $_[1] : 1;
}

sub cout 
{
	my ($str) = "@_ [thread ".threads->tid()."]";
	$str .= " " x (78 - length $str) if length $str < 79;
	print $str."\n";
	$str = '';
	$str .= '[ '.$_.' - '.$stats{$_}.' ]' for keys %stats;
	print $str.'[threads: '.(scalar threads->list() + 1)."]\r";
}
